C
C Divide "m" points in "n"-dimensional space into "k" clusters
C
	subroutine kmeans(a, m, n, mm, c, k, itermax, ic1, wss, nc)

	real a(m, n)	! "m" points in "n"-dimensional space
	integer m, n
	integer mm	!  effective x sample size; used instead of m
	real d(m)
	real c(k, n)	! cluster centers
	real an1(k), an2(k)
	real wss(k)	! withinss
	integer k 	! number of clusters applied for "kmns"
	integer itermax ! max of iterations applied for "kmns"

	integer ic1(m)	! cluster ID
	integer ic2(m)
	integer nc(k)	! cluster size
	integer ncp(k), itran(k), live(k)

	external kmns

C
C	set initial cluster centers
	do i = 1, k
		do j = 1, n
			c(i, j) = a(i, j)
		enddo
	enddo

	! do i = 1, mm
	! 	write(6,*)(a(i,j), j=1,n)
	! enddo
        write(6,*) 'm(kemans) =', m
        write(6,*) 'n(kemans)=', n
        write(6,*) 'mm(kemans)=', mm
        write(6,*) 'k(kemans) =', k

        call kmns (a, m, n, mm, c, k, ic1, ic2, nc, an1, an2, ncp, d,
     *    itran, live, itermax, wss, ifault)

        ! write(6,*) 'ifault =', ifault
        if (ifault == 1) then
		write(6,*) 'Err: empty cluster: try a better set of initial centers'
                stop
        else if (ifault == 2) then
		write(6,*) 'Warn: did not converge in itermax iterations'
        else if (ifault == 3) then
                ! 'kmns' returns ifault = 3, when it normal terminated.
                if (k .le. 1 .or. k .ge. m) then
			write(6,*) 'Err: number of cluster centres must lie between 1 and nrow(x)'
                        write(6,*) 'k =', k
                        write(6,*) 'm =', m
                        stop
		else
			ifault = 0
                end if
        end if

        write(6,*) 'ifault =', ifault
        write(6,*) 'wss = ', (wss(i), i = 1, k) ! withinss
C       write(6,*) 'an1 = ', (an1(i), i = 1, k)
C       write(6,*) 'an2 = ', (an2(i), i = 1, k)
C       write(6,*) 'd = ', (d(i), i = 1, mm)
        ! write(6,*) 'nc = ', (nc(i), i = 1, k)   ! size
C       write(6,*) 'itran = ', (itran(i), i = 1, k)
C       write(6,*) 'live = ', (live(i), i = 1, k)
C       write(6,*) 'iter = ', iter
        do i = 1, k
        	write(6,*) 'c(', i, ',)=', (c(i, j), j = 1, n)  ! centers
        enddo
        write(6,*) 'ic1 = ', (ic1(i), i = 1, mm) ! cluster
C       write(6,*) 'ic2 = ', (ic2(i), i = 1, mm)

	return
	end
