C
C $Id: xmeanMain.f,v 2.0 2004/11/30 09:33:38 tunenori Exp $
C Divide "m" points in "n"-dimensional space into "k" clusters by     
C     repeating kmeans that divided 2 clusters. The stopping criterion is BIC.

	program xmeans
	
	implicit none

	include "xmeans.h"
	integer k
        parameter(k = 5)        ! number of clusters applied for "kmeans"

	 

	real x(m, n)            ! "m" points in 2 dimensional space
        common /datax/ x

	real tarray(2), result, resultx, resultk
	intrinsic dtime

C 	for "kmeans" ...
	real c(k, n)	! centers
	integer  ic1(m) ! cluster ID
        common /icls1/ ic1
	real wss(k)	! withinss
	integer  nc(k)	! cluster size
	

C	for "M-T random numbers ...
	integer iseed	! seed of random numbers	
	real genrand, nrnd, w1, w2
	real grnd

	external genrand !  one pseudorandom real number (double)
	external grnd
	external sgenrand
	
C	for "xmeans"...
	integer icluster(m)     ! cluster ID for each element of x
        common /icls/ icluster
	real  centers(kmax, n)	! centers(kx, n) is meaningful
	real  lnL(kmax)		! lnL(kx, n) is meaningful
	integer  isize(kmax)	! isize(kx) is meaningful

	integer	kx ! final number of generated clusters by "xmeans"
	integer i, i5

	iseed = 10	! iseed = 4376, Initializing the array with this seed;
			! Do NOT use parameter statement
			! since sgenrand() is written in C.

C	call sgenrand(iseed)	! C
	call sgrnd(iseed)	! fortran
	
	do i = 1, m
C        	w1 = nrnd(genrand)	! C
C        	w2 = nrnd(genrand)	
        	w1 = nrnd(grnd)	! fortran
        	w2 = nrnd(grnd)
 		i5 = mod(i, 5)	! divide "x" to 5 clusters
 		if (i5 .eq. 1) then
 			x(i, 1) = w1 * 0.2 + 0.0
 			x(i, 2) = w2 * 0.2 + 0.0
 		else if (i5 .eq. 2) then
 			x(i, 1) = w1 * 0.3 - 2.0
 			x(i, 2) = w2 * 0.3 + 0.0
 		else if (i5 .eq. 3) then
 			x(i, 1) = w1 * 0.3 + 2.0
 			x(i, 2) = w2 * 0.3 + 0.0
 		else if (i5 .eq. 4) then
 			x(i, 1) = w1 * 0.3 + 0.0
 			x(i, 2) = w2 * 0.3 + 2.0
 		else	
 			x(i, 1) = w1 * 0.3 + 0.0
 			x(i, 2) = w2 * 0.3 - 2.0
 		end if
 		! i5 = mod(i, 10)	! divide "x" to 10 clusters
 		! if (i5 .eq. 1) then
		! 	x(i, 1) = w1 * 0.3 - 2.0
		! 	x(i, 2) = w2 * 0.3 + 2.0
 		! else if (i5 .eq. 2) then
 		! 	x(i, 1) = w1 * 0.3 + 0.0
 		! 	x(i, 2) = w2 * 0.3 + 2.0
 		! else if (i5 .eq. 3) then
 		! 	x(i, 1) = w1 * 0.3 + 2.0
 		! 	x(i, 2) = w2 * 0.3 + 2.0
 		! else if (i5 .eq. 4) then
 		! 	x(i, 1) = w1 * 0.3 - 2.0
 		! 	x(i, 2) = w2 * 0.3 + 0.0
 		! else if (i5 .eq. 5) then
 		! 	x(i, 1) = w1 * 0.3 + 0.0
 		! 	x(i, 2) = w2 * 0.3 + 0.0
 		! else if (i5 .eq. 6) then
 		! 	x(i, 1) = w1 * 0.3 + 2.0
 		! 	x(i, 2) = w2 * 0.3 + 0.0
 		! else if (i5 .eq. 7) then
 		! 	x(i, 1) = w1 * 0.3 - 2.0
 		! 	x(i, 2) = w2 * 0.3 - 2.0
 		! else if (i5 .eq. 8) then
 		! 	x(i, 1) = w1 * 0.3 + 0.0
 		! 	x(i, 2) = w2 * 0.3 - 2.0
 		! else if (i5 .eq. 9) then
 		! 	x(i, 1) = w1 * 0.3 + 2.0
 		! 	x(i, 2) = w2 * 0.3 - 2.0
 		! else
 		! 	x(i, 1) = w1 * 0.3 + 4.0
 		! 	x(i, 2) = w2 * 0.3 + 0.0
		! endif
        	! write(6,*) x(i, 1), x(i, 2)
	enddo 
	
	call dtime(tarray, result)
        write(6,*) 'm(main) =', m
	write(6,*) 'n(main) =', n
	write(6,*) 'k(main) =', k
	write(6,*) 'max(2,ik) =', max(2,ik)
	write(6,*) 'itermax =', itermax


	! call xmns (x, m, n, max(2,ik), kmax, itermax, icluster, centers, lnL, isize, kx)
	call xmns (centers, lnL, isize, kx)
	call dtime(tarray, resultx)

	call kmeans (x, m, n, m, c, k, itermax, ic1, wss, nc) ! kx is used
	call dtime(tarray, resultk)
	
	write(6,*) 'final result'
	write(6,*) 'icluster=', (icluster(i), i=1, m)
	write(6,*) 'centers='; call print_x2(centers, kmax, n, kx)
	write(6,*) 'lnL=', (lnL(i),i=1, kx)
	write(6,*) 'isize=', (isize(i), i=1, kx)

	write(6,*) 'time = ', result
	write(6,*) 'time (xmns) = ', resultx
	write(6,*) 'time (kmeans) = ', resultk

	stop
	end
